# -*- coding: utf-8 -*-
        
#--- constants ------------------------------------------------------------
PluginName = "ScreenCallsScreen"
PluginVersion = "1.0"
PluginTitle = PluginName + " (Ver. " + PluginVersion + ")"

# plugin header
from Plugins.Plugin import PluginDescriptor

# GUI
from Screens.Screen import Screen
from Components.Label import Label
from Components.ActionMap import ActionMap
           
class Screen1(Screen):        
    skin = '''<screen position="100,100" size="450,450" title="''' + PluginTitle +"**1" + '''">
            <ePixmap pixmap="skin_default/buttons/red.png" position="0,0" size="140,40" transparent="1" alphatest="on" />
            <ePixmap pixmap="skin_default/buttons/green.png" position="140,0" size="140,40" transparent="1" alphatest="on" />
            <widget name="key_red" position="0,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
            <widget name="key_green" position="140,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
            <widget name="screentext" position="200,200" zPosition="1" size="100,40" font="Regular;20" />
            </screen>'''
  
    def __init__(self, session, args = None):
        self.session = session
        Screen.__init__(self, session)

        self["key_red"] = Label(_("Screen 2"))
        self["key_green"] = Label(_("Screen 3"))        
        self["screentext"] = Label(_("Screen 1"))
        
        self["actions"] = ActionMap(["OkCancelActions", "ColorActions"], 
                                    {"red": self.callScreen2,
                                     "green": self.callScreen3,
                                     "cancel": self.exit}, -1)   
    
    def callScreen2(self):
        self.session.openWithCallback(self.closeScreen1, Screen2)     
    
    def callScreen3(self):
        self.session.openWithCallback(self.closeScreen1, Screen3)  
        
    def closeScreen1(self):
        self.close()

    def exit(self):
        self.close()
           
class Screen2(Screen):        
    skin = '''<screen position="100,100" size="800,450" title="''' + PluginTitle+"**2" + '''">
            <ePixmap pixmap="skin_default/buttons/red.png" position="0,0" size="140,40" transparent="1" alphatest="on" />
            <ePixmap pixmap="skin_default/buttons/green.png" position="140,0" size="140,40" transparent="1" alphatest="on" />
            <widget name="key_red" position="0,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
            <widget name="key_green" position="140,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
            <widget name="screentext" position="200,200" zPosition="1" size="100,40" font="Regular;20" />
            </screen>'''
 
    def __init__(self, session, args = None):
        self.session = session
        Screen.__init__(self, session)

        self["key_red"] = Label(_("Screen 1"))        
        self["key_green"] = Label(_("Screen 3"))
        self["screentext"] = Label(_("Screen 2"))
        
        self["actions"] = ActionMap(["OkCancelActions", "ColorActions"], 
                                    {"red": self.callScreen1, 
                                     "green": self.callScreen3,
                                     "cancel": self.exit}, -1)          
    
    def callScreen1(self):
        self.session.openWithCallback(self.closeScreen2, Screen1)
            
    def callScreen3(self):
        self.session.openWithCallback(self.closeScreen2, Screen3)
  
    def closeScreen2(self):
        self.close()

    def exit(self):
        self.close()

class Screen3(Screen):        
    skin = '''<screen position="100,100" size="800,450" title="''' + PluginTitle+"**3" + '''">
            <ePixmap pixmap="skin_default/buttons/red.png" position="0,0" size="140,40" transparent="1" alphatest="on" />
            <ePixmap pixmap="skin_default/buttons/green.png" position="140,0" size="140,40" transparent="1" alphatest="on" />
            <widget name="key_red" position="0,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
            <widget name="key_green" position="140,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
            <widget name="screentext" position="200,200" zPosition="1" size="100,40" font="Regular;20" />
            </screen>'''
  
    def __init__(self, session, args = None):
        self.session = session
        Screen.__init__(self, session)

        self["key_red"] = Label(_("Screen 1"))        
        self["key_green"] = Label(_("Screen 2"))
        self["screentext"] = Label(_("Screen 3"))
        
        self["actions"] = ActionMap(["OkCancelActions", "ColorActions"], 
                                    {"red": self.callScreen1, 
                                     "green": self.callScreen2,
                                     "cancel": self.exit}, -1)          
            
    def callScreen1(self):
        self.session.openWithCallback(self.closeScreen3, Screen1)   
            
    def callScreen2(self):
        self.session.openWithCallback(self.closeScreen3, Screen2)   
            
    def closeScreen3(self):
        self.close()

    def exit(self):
        self.close()  

#--- main program to display setup screen--------------------------------------------
def Start(session, **kwargs):
    session.open(Screen1)
          
#--- Plugin in PluginMenu ------------------------------------------------------------
def Plugins(**kwargs):
    return [
            PluginDescriptor(name= PluginName, 
                             description = PluginTitle,
                             where = PluginDescriptor.WHERE_PLUGINMENU, 
                             fnc=Start
                             )
            ]
    



